unit Unit1;

interface

//132x176

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  JvComponentBase, JvHidControllerClass, StdCtrls, ExtCtrls, jpeg, Spin,pbs,resample;

type
  TMainForm = class(TForm)
    JvHidDeviceController: TJvHidDeviceController;
    LogMemo: TMemo;
    Image: TImage;
    Image_: TImage;
    EndTimer: TTimer;
    WorkTimer: TTimer;
    function JvHidDeviceControllerEnumerate(HidDev: TJvHidDevice;  const Idx: Integer): Boolean;
    procedure FormCreate(Sender: TObject);
    procedure mainlog(t:string);
    procedure JvHidDeviceControllerDeviceChange(Sender: TObject);
    procedure JvHidDeviceControllerDeviceData(HidDev: TJvHidDevice; ReportID: Byte; const Data: Pointer; Size: Word);
    procedure EndTimerTimer(Sender: TObject);
    procedure WorkTimerTimer(Sender: TObject);
    procedure down_load_picture(start_or_continue:boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
    Dev: TJvHidDevice;
    MainForm: TMainForm;
    Raw:array[0..251] of byte;
    brightness:integer;
    power,show_form:boolean;
    picture:string;
    dev_status:integer;
    x,y:integer;
    to_send,tc:word;

implementation

{$R *.DFM}

procedure TMainForm.mainlog(t:string);
var
i:integer;
ScrollMessage:TWMVScroll;
begin
while pos(#13,t)<>0 do
    delete(t,pos(#13,t),1);
while pos(#10,t)<>0 do
    delete(t,pos(#10,t),1);
try
  logmemo.Lines.BeginUpdate;
  if length(t)>0 then
     if length(t)>2 then
        logmemo.lines.Append(datetimetostr(now)+' '+t)
     else
        logmemo.lines.Append('');
  ScrollMessage.Msg:=WM_VScroll;
  for i := logmemo.Lines.Count DownTo 0 do
        begin
        ScrollMessage.ScrollCode:=sb_LineDown;
        ScrollMessage.Pos:=0;
        logmemo.Dispatch(ScrollMessage);
        end;
  logmemo.Lines.EndUpdate;
  logmemo.update;
except
end;
end;

function TMainForm.JvHidDeviceControllerEnumerate(HidDev: TJvHidDevice;
  const Idx: Integer): Boolean;
begin
 EndTimer.Enabled:=true;
 mainlog( format('VendorID:%4.4X ProductID:%4.4X Name:%s ',[HidDev.Attributes.VendorID,HidDev.Attributes.ProductID,HidDev.ProductName]) );
//11.03.2011 13:45:37 VendorID:03F0 ProductID:0024 Name:HP Basic USB Keyboard
//11.03.2011 13:45:37 VendorID:046D ProductID:C018 Name:USB Optical Mouse
//11.03.2011 13:45:38 VendorID:051D ProductID:0002 Name:Back-UPS CS 650 FW:817.v4.I USB FW:v4
 if (HidDev.Attributes.VendorID=$16C0 ) and (HidDev.Attributes.ProductID=$15DF) then
 //if (HidDev.Attributes.VendorID=$051D ) and (HidDev.Attributes.ProductID=$0002) then
  begin
  Dev:=HidDev;
  Dev.CheckOut;
  EndTimer.Enabled:=false;
  Worktimer.Enabled:=true;
  mainlog('Dev.CheckedOut!');
  end;
 Result:=True;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
i:integer;
temp:string;
jpg:Tjpegimage;
bmp:Timage;
begin
logmemo.Lines.Clear;
image_.Canvas.FillRect(rect(0,0,175,131));

tc:=0;
dev_status:=-1;
brightness:=-1;
power:=true;
show_form:=false;
picture:='';
for i:=0 to paramcount do
   begin
   temp:=paramstr(i);
   getboolvalue(temp,'power',power);
   getstrvalue(temp,'picture',picture);
   getintvalue(temp,'brightness',brightness);
   getboolvalue(temp,'show_form',show_form);
   end;
if brightness>0 then
   if brightness>100 then brightness:=100;
mainlog(cmdline);
mainlog('power='+if_str(power,'True','False'));
mainlog('picture='+picture);
mainlog('brightness='+inttostr(brightness));
mainlog('show_form='+if_str(show_form,'True','False'));
if power=true then
 if length(picture)>0 then
   try
       bmp:=Timage.Create(nil);
       jpg:=Tjpegimage.Create;
       try
          if comparestr(ansilowercase(extractfileext(picture)),'.jpg')=0 then
              begin
              jpg.LoadFromFile(picture);
              bmp.Height:=Jpg.Height;
              bmp.Width :=Jpg.Width ;
              bmp.Canvas.Draw(0,0,Jpg);
              end;
          if comparestr(ansilowercase(extractfileext(picture)),'.bmp')=0 then
              bmp.Picture.LoadFromFile(picture);
          Strecth(bmp.Picture.Bitmap,Image.Picture.Bitmap, ResampleFilters[1{5}].Filter, ResampleFilters[1{5}].Width);
          //Image.Picture.SaveToFile('temp.bmp');
          //  ... :(
          mainlog(' !');
       finally
         jpg.Free;
         bmp.Free;
       end;
   except
       mainlog('  /  "'+picture+'"!');
       mainlog('     .');
       show_form:=true;//,   
   end;
if show_form=true then
   mainform.Show
else
   EndTimer.Interval:=1000;
//EndTimer.Interval:=10000;   
end;

procedure TMainForm.JvHidDeviceControllerDeviceChange(Sender: TObject);
begin
  Dev:=nil;
  JvHidDeviceController.Enumerate;
  mainlog('HidDeviceController.Enumerate started!');
  //EndTimer.Enabled:=true;
end;

procedure TMainForm.JvHidDeviceControllerDeviceData(HidDev: TJvHidDevice; ReportID: Byte; const Data: Pointer; Size: Word);
var
temp:string;
i:integer;
begin
if dev=nil then exit;
fillchar(Raw,length(RAW),0);
move(Data^,Raw[0],Size);
if (raw[0]=100) and (dev_status=2) then
   down_load_picture(false)
else
   begin
   if (power=true) or (dev_status<0) then
      worktimer.Enabled:=true;
   dev_status:=raw[6];
   mainlog('HidDeviceControllerDeviceData event   '+format('ReportID=%2.2X  size=%2.2X',[ReportID,size]));
   temp:='';
   for i:=0 to 10 do
     temp:=temp+format(' %2.2X', [Raw[i]]);
   mainlog(temp);
   end;
end;

procedure TMainForm.down_load_picture(start_or_continue:boolean);
var
 r:byte;
 g:byte;
 b:byte;
 tmp_r:byte;
 tmp_g:byte;
 tmp_b:byte;
 tmpw:word;
begin
 if Dev=nil then exit;
 WorkTimer.Enabled:=false;
 if start_or_continue=true then
    begin
    tc:=0;
    to_send:=1;
    fillchar(Raw,length(RAW),0);
    Raw[0]:=$10;  //ReportID
    mainlog('Picture download start');
    y:=0;
    x:=0;
    end;
 while ((to_send+1<>Dev.Caps.FeatureReportByteLength-1) and (tc<46464)) do
        begin
        r:= GetRValue(ColorToRGB(image.Canvas.Pixels[y,image.Height-x]));
        g:= GetGValue(ColorToRGB(image.Canvas.Pixels[y,image.Height-x]));
        b:= GetBValue(ColorToRGB(image.Canvas.Pixels[y,image.Height-x]));
        image_.Canvas.Pixels[y,image.Height-x]:=image.Canvas.Pixels[y,image.Height-x];
        tmp_r:=r and $F8;
        tmp_g:=g and $FC;
        tmp_b:=b and $F8;
        tmpw:=(word(tmp_r) shl 8)or(word(tmp_g) shl 3)or(word(tmp_b) shr 3);
        raw[to_send+1]:=byte(tmpw);
        raw[to_send]:=byte((tmpw shr 8));
        to_send:=to_send+2;
        tc:=tc+2;
        if x>=131 then
           begin
           x:=0;
           y:=y+1;
           end
        else
           x:=x+1;
        end;
 //     
 if to_send>1 then
      begin
      Raw[0]:=$10;  //ReportID
      raw[251]:=to_send;
      Dev.SetFeature(Raw,Dev.Caps.FeatureReportByteLength);
      fillchar(Raw,length(RAW),0);
      to_send:=1;
      end
 else
      begin
      mainlog('Picture download end');
      EndTimer.Enabled:=true;
      end;
end;

procedure TMainForm.EndTimerTimer(Sender: TObject);
begin
halt;
end;

procedure TMainForm.WorkTimerTimer(Sender: TObject);
var
 res:boolean;
 dwWrited:DWORD;
begin
Worktimer.Enabled:=false;
try
  if dev<>nil then
     begin
       //EndTimer.Enabled:=false;
       mainlog('Dev_status='+inttostr(dev_status));
       fillchar(Raw,length(RAW),0);
       Raw[0]:=$30;  //ReportID
       if dev_status<0 then
          begin
          Raw[1]:=0; //get_status
          Dev.WriteFile(Raw,DEv.Caps.OutputReportByteLength,dwWrited);
          mainlog('get_status!');
          end
       else
          begin
          if dev_status=0 then
            begin
            if power=true then
              begin
              if dev_status=0 then
                 begin
                 Raw[1]:=1; //power_up
                 mainlog('power up!');
                 end;
              end
            else
              begin
              Raw[1]:=10; //power_down
              mainlog('power down!');
              EndTimer.Enabled:=true; // 
              end;
            Dev.WriteFile(Raw,DEv.Caps.OutputReportByteLength,dwWrited);
            end;
          if dev_status=10 then
            begin
            if power=true then
              begin
              Raw[1]:=1; //power_up
              mainlog('power up!');
              Dev.WriteFile(Raw,DEv.Caps.OutputReportByteLength,dwWrited);
              end
            else
              EndTimer.Enabled:=true; // 
            end;
          if dev_status=1 then
            begin
            Raw[1]:=2; //init
            Dev.WriteFile(Raw,DEv.Caps.OutputReportByteLength,dwWrited);
            mainlog('Lcd init!');
            end;
          if (dev_status=2) and (power=false) then
            begin
            Raw[1]:=10; //power_down
            mainlog('power down!');
            EndTimer.Enabled:=true; // 
            Dev.WriteFile(Raw,DEv.Caps.OutputReportByteLength,dwWrited);
            end;
          if ((dev_status=2) and (brightness<0) and (tc=0)) then           //  ?
            begin
            if length(picture)>0 then//  ...
                begin
                mainlog('down_load_picture (first)!');
                down_load_picture(true) //  
                end
            else
                EndTimer.Enabled:=true; // 
            end;
          if ((dev_status=2) and (brightness>0)) then           //  ?
            begin
            Raw[1]:=3; //  MFU
            Raw[2]:=1; //  PWM
            Raw[3]:=$02; //02!!! //0x08=5,9   0x04=12  002=23,4  001=46
            Raw[4]:=$00;
            Raw[5]:=$00;  //OCR1AH_t=ct[3];   //dity cicle 0x00=12,5%  0x01=25% 0x06=90%  0x08=100%
            Raw[6]:=byte(round(brightness*255/100));//   $ff;//00-ff  //OCR1AL_t=ct[4];   //0XFF!!!
            Dev.WriteFile(Raw,DEv.Caps.OutputReportByteLength,dwWrited);
            brightness:=-1;
            mainlog('set brightness!');
            end;
          end;
     end
  else
     EndTimer.Enabled:=true; // 
finally
if (power=true) or (dev_status>0) then
  Worktimer.Enabled:=true;
end;
end;

end.
